Index: trunk/LMDZ.GENERIC/libf/phystd/rain.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 728)
@@ -2,6 +2,8 @@
 
 
-  use watercommon_h, only: T_h2O_ice_liq,T_h2O_ice_clouds, RLVTT, RCPD, RCPV, RV, RVTMP2
-
+! to use  'getin'
+  use ioipsl_getincom 
+  use watercommon_h, only: T_h2O_ice_liq,T_h2O_ice_clouds, RLVTT, RCPD, RCPV, RV, RVTMP2,Psat_water,Tsat_water,rhowater
+  use radii_mod, only: h2o_cloudrad
   implicit none
 
@@ -15,4 +17,5 @@
 !     -------
 !     Adapted from the LMDTERRE code by R. Wordsworth (2009)
+!     Added rain vaporization in case of T>Tsat
 !     Original author Z. X. Li (1993)
 !     
@@ -51,12 +54,17 @@
       PARAMETER (seuil_neb=0.001)
 
-      REAL,PARAMETER :: cl=2.0e-4                          ! Precipitation threshold
-      REAL,PARAMETER :: ct=1./1800.                        ! Precipitation rate
+      INTEGER,save :: precip_scheme      ! id number for precipitaion scheme
+!     for simple scheme  (precip_scheme=1)
+      REAL,SAVE :: rainthreshold                ! Precipitation threshold in simple scheme
+!     for sundquist scheme  (precip_scheme=2-3)
+      REAL,SAVE :: cloud_sat                    ! Precipitation threshold in non simple scheme
+      REAL,SAVE :: precip_timescale             ! Precipitation timescale
+!     for Boucher scheme  (precip_scheme=4)
+      REAL,SAVE :: Cboucher ! Precipitation constant in Boucher 95 scheme
+      REAL,PARAMETER :: Kboucher=1.19E8
+      REAL,SAVE :: c1
 
       INTEGER ninter
       PARAMETER (ninter=5)
-
-      logical simple                    ! Use very simple Emanuel scheme?
-      parameter(simple=.true.)
 
       logical evap_prec                 ! Does the rain evaporate?
@@ -68,15 +76,7 @@
       real lconvert
 
-!     for precipitation evaporation (old scheme)
-      real eeff1
-      real eeff2
-!      parameter (eeff1=0.95)
-!      parameter (eeff2=0.98)
-      parameter (eeff1=0.5)
-      parameter (eeff2=0.8)
-
 !     Local variables
       INTEGER i, k, n
-      REAL zqs(ngridmx,nlayermx), zdelta, zcor
+      REAL zqs(ngridmx,nlayermx),Tsat(ngridmx,nlayermx), zdelta, zcor
       REAL zrfl(ngridmx), zrfln(ngridmx), zqev, zqevt
 
@@ -85,5 +85,7 @@
       REAL zchau(ngridmx),zfroi(ngridmx),zfrac(ngridmx),zneb(ngridmx)
 
-      real ttemp, ptemp
+      real reffh2oliq(ngridmx,nlayermx),reffh2oice(ngridmx,nlayermx)
+  
+      real ttemp, ptemp, psat_tmp
       real tnext(ngridmx,nlayermx)
 
@@ -115,4 +117,34 @@
          PRINT*, 'in rain.F, ninter=', ninter
          PRINT*, 'in rain.F, evap_prec=', evap_prec
+
+         write(*,*) "Precipitation scheme to use?"
+         precip_scheme=1 ! default value
+         call getin("precip_scheme",precip_scheme)
+         write(*,*) " precip_scheme = ",precip_scheme
+
+         if (precip_scheme.eq.1) then
+	    write(*,*) "rainthreshold in simple scheme?"
+            rainthreshold=0. ! default value
+            call getin("rainthreshold",rainthreshold)
+            write(*,*) " rainthreshold = ",rainthreshold
+
+         else if (precip_scheme.eq.2.or.precip_scheme.eq.3) then
+	    write(*,*) "cloud water saturation level in non simple scheme?"
+            cloud_sat=2.6e-4   ! default value
+            call getin("cloud_sat",cloud_sat)
+            write(*,*) " cloud_sat = ",cloud_sat
+	    write(*,*) "precipitation timescale in non simple scheme?"
+            precip_timescale=3600.  ! default value
+            call getin("precip_timescale",precip_timescale)
+            write(*,*) " precip_timescale = ",precip_timescale
+
+         else if (precip_scheme.eq.4) then
+	    write(*,*) "multiplicative constant in Boucher 95 precip scheme"
+            Cboucher=1.   ! default value
+            call getin("Cboucher",Cboucher)
+            write(*,*) " Cboucher = ",Cboucher	
+	    c1=1.00*1.097/rhowater*Cboucher*Kboucher  
+
+	 endif
 
          firstcall = .false.
@@ -158,5 +190,7 @@
             ttemp = zt(i,k) 
             ptemp = pplay(i,k)
-            call watersat(ttemp,ptemp,zqs(i,k))
+!            call watersat(ttemp,ptemp,zqs(i,k))
+	    call Psat_water(ttemp,ptemp,psat_tmp,zqs(i,k))
+	    call Tsat_water(ptemp,Tsat(i,k))
          ENDDO
       ENDDO
@@ -180,26 +214,28 @@
                IF (zrfl(i) .GT.0.) THEN
 
-                  zqev     = MAX (0.0, (zqs(i,k)-q(i,k)))/ptimestep! BC modif here
-                  zqevt    = 2.0e-5*(1.0-q(i,k)/zqs(i,k))    &
-                       *sqrt(zrfl(i))*l2c(i,k)/pplay(i,k)*zt(i,k)*R ! BC modif here
-                  zqevt    = MAX (zqevt, 0.0)
-                  zqev     = MIN (zqev, zqevt)
-                  zqev     = MAX (zqev, 0.0)
-                  zrfln(i) = zrfl(i) - zqev
-		  zrfln(i) = max(zrfln(i),0.0)
-
-                  !zqev     = MAX (0.0, (zqs(i,k)-q(i,k))*eeff1 )
-                  !zqevt    = (zrfl(i)/l2c(i,k))*eeff2
-                  !zqev     = MIN (zqev, zqevt)
-                  !zrfln(i) = zrfl(i) - zqev*l2c(i,k)
-                  !zrfln(i)  = zrfl(i) - 1.5e-5*(1.0-q(i,k)/zqs(i,k))*sqrt(zrfl(i))
-                  !zrfln(i)  = min(zrfln(i),zrfl(i))
-                  ! this is what is actually written in the manual
-
-                  d_q(i,k) = - (zrfln(i)-zrfl(i))/l2c(i,k)*ptimestep
-                  !d_t(i,k) = d_q(i,k) * RLVTT/RCPD!/(1.0+RVTMP2*q(i,k)) ! double BC modif here
-                  d_t(i,k) = - d_q(i,k) * RLVTT/RCPD ! was bugged!
-  
-                  zrfl(i)  = zrfln(i)
+                  if(zt(i,k).gt.Tsat(i,k))then
+!		     print*,'in rain',i,k,zrfl(i),zt(i,k),Tsat(i,k)
+		     zqev=MIN((zt(i,k)-Tsat(i,k))*RCPD*l2c(i,k)/RLVTT,zrfl(i))
+		     zrfl(i)=MAX(zrfl(i)-zqev,0.)
+		     d_q(i,k)=zqev/l2c(i,k)
+		     d_t(i,k) = - d_q(i,k) * RLVTT/RCPD
+!		     print*,zqev,zrfl(i),d_q(i,k),d_t(i,k)
+		  else
+                     zqev = MAX (0.0, (zqs(i,k)-q(i,k)))/ptimestep! there is a bug here
+                     zqevt= 2.0e-5*(1.0-q(i,k)/zqs(i,k))    & !default was 2.e-5
+                        *sqrt(zrfl(i))*l2c(i,k)/pplay(i,k)*zt(i,k)*R ! BC modif here
+                     zqevt = MAX (zqevt, 0.0)
+                     zqev  = MIN (zqev, zqevt)
+                     zqev  = MAX (zqev, 0.0)
+                     zrfln(i)= zrfl(i) - zqev
+		     zrfln(i)= max(zrfln(i),0.0)
+
+                     d_q(i,k) = - (zrfln(i)-zrfl(i))/l2c(i,k)*ptimestep
+                     !d_t(i,k) = d_q(i,k) * RLVTT/RCPD!/(1.0+RVTMP2*q(i,k)) ! double BC modif here
+                     d_t(i,k) = - d_q(i,k) * RLVTT/RCPD ! was bugged!
+                     zrfl(i)  = zrfln(i)
+		  end if
+		     
+
                ENDIF
             ENDDO
@@ -211,5 +247,5 @@
 
 
-         if(simple)then
+         if(precip_scheme.eq.1)then
 
             DO i = 1, ngridmx
@@ -234,6 +270,6 @@
             ENDDO
 
-         else
-
+         elseif (precip_scheme.ge.2) then
+          
             DO i = 1, ngridmx
                IF (rneb(i,k).GT.0.0) THEN
@@ -248,11 +284,15 @@
             ENDDO
 
+           SELECT CASE(precip_scheme)
+ !precip scheme from Sundquist 78
+ 	   CASE(2)
+
             DO n = 1, ninter
                DO i = 1, ngridmx
                   IF (rneb(i,k).GT.0.0) THEN
-                     zchau(i) = (ct*ptimestep/FLOAT(ninter)) * zoliq(i)      &
-                          * (1.0-EXP(-(zoliq(i)/zneb(i)/cl)**2)) * zfrac(i)
-
-                     ! this is the ONLY place where zneb, ct and cl are used
+                     ! this is the ONLY place where zneb, precip_timescale and cloud_sat are used
+
+                     zchau(i) = (ptimestep/(FLOAT(ninter)*precip_timescale)) * zoliq(i)      &
+                          * (1.0-EXP(-(zoliq(i)/zneb(i)/cloud_sat)**2)) * zfrac(i)
                      zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
                      zfroi(i) = ptimestep/FLOAT(ninter)/zdz(i)*zoliq(i)    &
@@ -268,4 +308,56 @@
                ENDDO
             ENDDO            
+
+ !precip scheme modified from Sundquist 78 (in q**3)
+	   CASE(3)	    
+	    
+            DO n = 1, ninter
+               DO i = 1, ngridmx
+                  IF (rneb(i,k).GT.0.0) THEN
+                     ! this is the ONLY place where zneb, precip_timescale and cloud_sat are used
+
+                     zchau(i) = (ptimestep/(FLOAT(ninter)*precip_timescale*cloud_sat**2)) * (zoliq(i)/zneb(i))**3  
+                     zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
+                     zfroi(i) = ptimestep/FLOAT(ninter)/zdz(i)*zoliq(i)    &
+                          *fallv(zrhol(i)) * (1.0-zfrac(i)) ! zfroi behaves oddly...
+!                          * 0.1 * (1.0-zfrac(i))
+                     ztot(i)  = zchau(i) + zfroi(i)
+
+                     IF (zneb(i).EQ.seuil_neb) ztot(i) = 0.0
+                     ztot(i)  = MIN(MAX(ztot(i),0.0),zoliq(i))
+                     zoliq(i) = MAX(zoliq(i)-ztot(i), 0.0)
+
+                  ENDIF
+               ENDDO
+            ENDDO            
+
+ !precip scheme modified from Boucher 95
+	   CASE(4)
+
+            !recalculate liquid water particle radii
+	    call h2o_cloudrad(ql,reffh2oliq,reffh2oice)
+
+            DO n = 1, ninter
+               DO i = 1, ngridmx
+                  IF (rneb(i,k).GT.0.0) THEN
+                     ! this is the ONLY place where zneb and c1 are used
+
+                     zchau(i) = ptimestep/FLOAT(ninter) *c1* zrho(i) &
+                                    *(zoliq(i)/zneb(i))**2*reffh2oliq(i,k)*zneb(i)* zfrac(i) 
+                     zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
+                     zfroi(i) = ptimestep/FLOAT(ninter)/zdz(i)*zoliq(i)    &
+                          *fallv(zrhol(i)) * (1.0-zfrac(i)) ! zfroi behaves oddly...
+!                          * 0.1 * (1.0-zfrac(i))
+                     ztot(i)  = zchau(i) + zfroi(i)
+
+                     IF (zneb(i).EQ.seuil_neb) ztot(i) = 0.0
+                     ztot(i)  = MIN(MAX(ztot(i),0.0),zoliq(i))
+                     zoliq(i) = MAX(zoliq(i)-ztot(i), 0.0)
+
+                  ENDIF
+               ENDDO
+            ENDDO            
+
+           END SELECT ! precip_scheme 
 
             ! Change in cloud density and surface H2O values
@@ -277,5 +369,6 @@
             ENDDO
 
-         endif ! if simple
+
+         endif ! if precip_scheme=1
 
  9999 continue
Index: trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 728)
@@ -26,4 +26,5 @@
 !     B. Charnay
 !     A. Spiga
+!     J. Leconte (2012)
 !
 !==================================================================
Index: trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90	(revision 728)
@@ -1,7 +1,10 @@
       subroutine su_watercycle
 
+! to use  'getin'
+      use ioipsl_getincom 
       use watercommon_h
       implicit none
 #include "comcstfi.h"
+#include "callkeys.h"
 
 
@@ -10,9 +13,10 @@
 !     Purpose
 !     -------
-!     Set up relevant constants and parameters for the water cycle
+!     Set up relevant constants and parameters for the water cycle, and water cloud properties
 !
 !     Authors
 !     -------
 !     Robin Wordsworth (2010)
+!     Jeremy Leconte (2012)
 !
 !==================================================================
Index: trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 728)
@@ -1,4 +1,5 @@
-      subroutine totalcloudfrac(rneb,totalrneb)
+      subroutine totalcloudfrac(rneb,totalrneb,pplev,pq,tau)
 
+      use watercommon_h
       implicit none
 
@@ -22,10 +23,17 @@
 #include "comgeomfi.h"
 #include "comdiurn.h"
+#include "callkeys.h"
+
 
       real rneb(ngridmx,nlayermx)             ! cloud fraction     
+      real pplev(ngridmx,nlayermx+1)
+      real pq(ngridmx,nlayermx,nqmx)
+      real tau(ngridmx,nlayermx)
+
       real totalrneb(ngridmx)                 ! total cloud fraction 
-
-      integer recovery
-      parameter(recovery=1)
+      real, dimension(nlayermx+1) :: masse
+      integer, parameter          :: recovery=7
+      integer ltau_max
+      real massetot
 
 ! hypothesis behind recovery. value: 
@@ -33,9 +41,12 @@
 ! 2 = maximal recovery
 ! 3 = minimal recovery
-
-
+! 4 = fixed recovery
+! 5 = recovery on the thicker layer
 !     Local variables
       integer ig, l
-      real clear
+      real clear,tau_min
+      real, parameter ::  tau_c=0.1 !threshold of optical depth for the calculation of total cloud fraction 
+      real rneb2(nlayermx)
+
 
       do ig=1,ngridmx
@@ -51,5 +62,5 @@
          elseif (recovery.eq.2) then
             totalrneb(ig) = rneb(ig,1)
-            do l=2,nlayermx       
+            do l=2,14 !nlayermx       
                totalrneb(ig) = max(rneb(ig,l),totalrneb(ig))
             enddo
@@ -60,6 +71,38 @@
                totalrneb(ig) = min(rneb(ig,l),totalrneb(ig))
             enddo
-         endif                  ! (recovery=)
          
+         elseif (recovery.eq.4) then
+            totalrneb(ig) = CLFfixval
+
+         elseif (recovery.eq.5) then
+            totalrneb(ig) = rneb(ig,1)            
+            do l=1,nlayermx
+               masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
+            enddo
+            ltau_max=maxloc(masse,dim=1)
+            totalrneb(ig) = rneb(ig,ltau_max)
+
+         elseif (recovery.eq.6) then
+            totalrneb(ig) = 0.            
+            do l=1,nlayermx
+               masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
+               masse(l)=max(masse(l),0.)
+            enddo
+            massetot=sum(masse,dim=1)
+            do l=1,nlayermx
+               totalrneb(ig) = totalrneb(ig)+rneb(ig,l)*masse(l)/massetot
+            enddo
+
+         elseif (recovery.eq.7) then
+
+            rneb2(:)=rneb(ig,1:nlayermx)
+	    tau_min=MIN(tau_c,MAXVAL(tau(ig,1:nlayermx))/2.)
+            do l=1,nlayermx
+               if(tau(ig,l)<tau_min) rneb2(l)=0.      	
+            enddo
+            totalrneb(ig)=maxval(rneb2(1:nlayermx))
+
+         endif                  ! (recovery=)   
+
          totalrneb(ig) = min(1.,totalrneb(ig))
          totalrneb(ig) = max(0.,totalrneb(ig))
Index: trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 728)
@@ -5,7 +5,7 @@
           pdufi,pdvfi,pdtfi,pdqfi,pfluxsrf,            &
           Pdudif,pdvdif,pdtdif,pdtsrf,sensibFlux,pq2,  &
-          pdqdif,pdqsdif,lastcall)
-
-      use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol
+          pdqdif,pdqevap,pdqsdif,lastcall)
+
+      use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol,Psat_water
       use radcommon_h, only : sigma
 
@@ -112,6 +112,9 @@
       INTEGER iq
       REAL zq(ngridmx,nlayermx,nqmx)
+      REAL zqnoevap(ngridmx,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL pdqevap(ngridmx,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL zdmassevap(ngridmx)
       REAL rho(ngridmx)         ! near-surface air density
-      REAL qsat(ngridmx)
+      REAL qsat(ngridmx),psat(ngridmx)
       DATA firstcall/.true./
       REAL kmixmin
@@ -119,8 +122,7 @@
 !     Variables added for implicit latent heat inclusion
 !     --------------------------------------------------
-      real dqsat(ngridmx), qsat_temp1, qsat_temp2
-
-      integer ivap, iliq, iliq_surf,iice_surf ! also make liq for clarity on surface...
-      save ivap, iliq, iliq_surf,iice_surf
+      real dqsat(ngridmx), qsat_temp1, qsat_temp2,psat_temp
+
+      integer, save :: ivap, iliq, iliq_surf,iice_surf ! also make liq for clarity on surface...
 
       real, parameter :: karman=0.4
@@ -203,4 +205,11 @@
             ENDDO
          ENDDO
+         if (water) then
+            DO ilev=1,nlay
+               DO ig=1,ngrid
+                  zqnoevap(ig,ilev)=pq(ig,ilev,ivap) + pdqfi(ig,ilev,ivap)*ptimestep
+               ENDDO
+            ENDDO
+         Endif
       end if
 
@@ -246,5 +255,5 @@
       end if
 
-!JL12 change zkv at the surface by zcdv to calculate the surface momentum properly
+!JL12 change zkv at the surface by zcdv to calculate the surface momentum flux properly
       DO ig=1,ngrid
          zkv(ig,1)=zcdv(ig)
@@ -253,5 +262,5 @@
  
 !JL12 calculate the flux coefficients (tables multiplied elements by elements)
-      zfluxv=zkv(:,1:nlay)*zb0
+      zfluxv(1:ngridmx,1:nlayermx)=zkv(1:ngridmx,1:nlayermx)*zb0(1:ngridmx,1:nlayermx)
       
 !-----------------------------------------------------------------------
@@ -344,11 +353,11 @@
          zcdv(ig) = zcdv_true(ig)*sqrt(zu2)
          zcdh(ig) = zcdh_true(ig)*sqrt(zu2)
-         zkh(ig,1)=zcdh(ig)
+         zkh(ig,1)= zcdh(ig)
       ENDDO
 
 !     JL12 calculate the flux coefficients (tables multiplied elements by elements)
 !     ---------------------------------------------------------------
-      zfluxq=zkh(:,1:nlay)*zb0 !JL12 we save zfluxq which doesn't need the Exner factor
-      zfluxt=zfluxq*zExner
+      zfluxq(1:ngridmx,1:nlayermx)=zkh(1:ngridmx,1:nlayermx)*zb0(1:ngridmx,1:nlayermx) !JL12 we save zfluxq which doesn't need the Exner factor
+      zfluxt(1:ngridmx,1:nlayermx)=zfluxq(1:ngridmx,1:nlayermx)*zExner(1:ngridmx,1:nlayermx)
 
 
@@ -502,12 +511,20 @@
 
                 ! Calculate the value of qsat at the surface (water)
-                call watersat(ptsrf(ig),pplev(ig,1),qsat(ig))
-                call watersat(ptsrf(ig)-0.0001,pplev(ig,1),qsat_temp1)
-                call watersat(ptsrf(ig)+0.0001,pplev(ig,1),qsat_temp2)
+                call Psat_water(ptsrf(ig),pplev(ig,1),psat(ig),qsat(ig))
+                call Psat_water(ptsrf(ig)-0.0001,pplev(ig,1),psat_temp,qsat_temp1)
+                call Psat_water(ptsrf(ig)+0.0001,pplev(ig,1),psat_temp,qsat_temp2)
                 dqsat(ig)=(qsat_temp2-qsat_temp1)/0.0002
                 ! calculate dQsat / dT by finite differences
                 ! we cannot use the updated temperature value yet...
- 
+!		if(qsat2(ig).gt.1.) then
+!		   qsat(ig)=1.
+!		   dqsat(ig)=0.
+!		else
+!		   qsat(ig)=qsat2(ig)
+!		endif
                enddo
+
+               call writediagfi(ngrid,'qsatused','saturation mixing ratio at surface','',2,qsat)
+               call writediagfi(ngrid,'psat','saturation pressure at surface','',2,psat)
 
 ! coefficients for q
@@ -632,5 +649,42 @@
            endif                ! if (water et iq=ivap)
         end do                  ! of do iq=1,nq
-      endif                     ! traceur
+
+        if (water) then  ! special case where we recompute water mixing without any evaporation.
+	                 !    The difference with the first calculation then tells us where evaporated water has gone
+
+            DO ig=1,ngrid
+               z1(ig)=1./(zmass(ig,nlay)+zfluxq(ig,nlay))
+               zcq(ig,nlay)=zmass(ig,nlay)*zqnoevap(ig,nlay)*z1(ig)
+               zdq(ig,nlay)=zfluxq(ig,nlay)*z1(ig)
+            ENDDO 
+            
+            DO ilay=nlay-1,2,-1
+               DO ig=1,ngrid
+                  z1(ig)=1./(zmass(ig,ilay)+zfluxq(ig,ilay)+zfluxq(ig,ilay+1)*(1.-zdq(ig,ilay+1)))
+                  zcq(ig,ilay)=(zmass(ig,ilay)*zqnoevap(ig,ilay)+zfluxq(ig,ilay+1)*zcq(ig,ilay+1))*z1(ig)
+                  zdq(ig,ilay)=zfluxq(ig,ilay)*z1(ig)
+               ENDDO
+            ENDDO
+
+            DO ig=1,ngrid
+               z1(ig)=1./(zmass(ig,1)+zfluxq(ig,2)*(1.-zdq(ig,2)))
+               zcq(ig,1)=(zmass(ig,1)*zqnoevap(ig,1)+zfluxq(ig,2)*zcq(ig,2))*z1(ig)
+            enddo
+
+!     Starting upward calculations for simple tracer mixing (e.g., dust)
+            do ig=1,ngrid
+               zqnoevap(ig,1)=zcq(ig,1)
+            end do
+
+            do ilay=2,nlay
+               do ig=1,ngrid
+                  zqnoevap(ig,ilay)=zcq(ig,ilay)+zdq(ig,ilay)*zqnoevap(ig,ilay-1)
+               end do
+            end do
+
+         endif               ! if water
+	
+	
+      endif                     ! tracer
 
 
@@ -659,8 +713,22 @@
             enddo
          enddo
+	 if (water) then
+            do ilev = 1, nlay
+               do ig=1,ngrid
+                  pdqevap(ig,ilev)=(zq(ig,ilev,ivap)-zqnoevap(ig,ilev))/ptimestep
+               enddo
+            enddo
+	    do ig=1,ngrid
+	       zdmassevap(ig)=SUM(pdqevap(ig,:)*zmass(ig,:))*ptimestep
+	    end do	    
+	 endif
       endif 
 
       if(water)then
-      call writediagfi(ngrid,'beta','Dryness coefficient',' ',2,dryness)
+         call writediagfi(ngrid,'beta','Dryness coefficient',' ',2,dryness)
+         if (tracer) then
+            call writediagfi(ngrid,'dqevap','evaporated water vapor specific concentration','s-1',3,pdqevap)
+            call writediagfi(ngrid,'h2oevap','evaporated water vapor mass','kg/m2',2,zdmassevap)
+	 endif
       endif
 
Index: trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 728)
@@ -1,3 +1,3 @@
-      module watercommon_h
+module watercommon_h
 
       implicit none
@@ -11,17 +11,156 @@
       real, parameter :: RLVTT = 2.257E+6 ! Latent heat of vaporization (J kg-1) 
       real, parameter :: RLSTT = 2.257E+6 ! 2.591E+6 in reality ! Latent heat of sublimation (J kg-1)
-      !real, parameter :: RLVTT = 0.0 
-      !real, parameter :: RLSTT = 0.0
 
       real, parameter :: RLFTT = 3.334E+5 ! Latent heat of fusion (J kg-1) ! entails an energy sink but better description of albedo
-      !real, parameter :: RLFTT = 0.0 
       real, parameter :: rhowater = 1.0E+3 ! mass of water (kg/m^3)
+      real, parameter :: rhowaterice = 9.2E+2 ! mass of water (kg/m^3)
       real, parameter :: capcal_h2o_liq = 4181.3 ! specific heat capacity of liquid water J/kg/K
       real, parameter :: mx_eau_sol = 150 ! mass of water (kg/m^2)
 
-!     This was the old Martian latent heat version:
-!     lw=(2834.3-0.28*(zt(ig,l)-To)-0.004*(zt(ig,l)-To)**2)*1.e+3
+      real, save :: epsi, RCPD, RCPV, RV, RVTMP2
+      
+      contains
 
-      real, save :: epsi, RCPD, RCPV, RV, RVTMP2
+      
+!==================================================================
+      subroutine Psat_water(T,p,psat,qsat)
 
-      end module watercommon_h
+         implicit none
+
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the saturation vapor pressure and mass mixing ratio at saturation (kg/kg)
+!     for a given pressure (Pa) and temperature (K)
+!     Based on the Tetens formula from L.Li physical parametrization manual
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+
+!        input
+         real, intent(in) :: T, p
+  
+!        output
+         real psat,qsat
+
+! JL12 variables for tetens formula
+         real,parameter :: Pref_solid_liquid=611.14
+         real,parameter :: Trefvaporization=35.86
+         real,parameter :: Trefsublimation=7.66
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
+
+! checked vs. old watersat data 14/05/2012 by JL.
+
+         if (T.lt.T_h2O_ice_liq) then ! solid / vapour
+            psat = Pref_solid_liquid*Exp(r3sublimation*(T-T_h2O_ice_liq)/(T-Trefsublimation))
+         else                 ! liquid / vapour
+            psat = Pref_solid_liquid*Exp(r3vaporization*(T-T_h2O_ice_liq)/(T-Trefvaporization))
+         endif
+         if(psat.gt.p) then
+            qsat=1.
+         else
+            qsat=epsi*psat/(p-(1.-epsi)*psat)
+         endif
+         return
+      end subroutine Psat_water
+
+
+
+
+!==================================================================
+      subroutine Lcpdqsat_water(T,p,psat,qsat,dqsat)
+
+         implicit none
+
+!==================================================================
+!     Purpose
+!     -------
+!     Compute L/cp*d (q_sat)/d T
+!     for a given temperature (K)! 
+!     Based on the Tetens formula from L.Li physical parametrization manual
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+
+!        input
+         real T, p, psat, qsat
+  
+!        output
+         real dqsat
+
+! JL12 variables for tetens formula
+         real,parameter :: Pref_solid_liquid=611.14
+         real,parameter :: Trefvaporization=35.86
+         real,parameter :: Trefsublimation=7.66
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
+
+         real :: dummy
+
+         if (psat.gt.p) then
+	    dqsat=0.
+	    return
+	 endif
+
+         if (T.lt.T_h2O_ice_liq) then ! solid / vapour
+            dummy = r3sublimation*(T_h2O_ice_liq-Trefsublimation)/(T-Trefsublimation)**2
+         else                 ! liquid / vapour
+            dummy = r3vaporization*(T_h2O_ice_liq-Trefvaporization)/(T-Trefvaporization)**2
+         endif
+
+         dqsat=RLVTT/RCPD*qsat**2*(p/(epsi*psat))*dummy
+         return
+      end subroutine Lcpdqsat_water
+
+
+
+
+!==================================================================
+      subroutine Tsat_water(p,Tsat)
+
+         implicit none
+
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the saturation temperature
+!     for a given pressure (Pa) 
+!     Based on the Tetens formula from L.Li physical parametrization manual
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+
+!        input
+         real p
+  
+!        output
+         real Tsat
+
+! JL12 variables for tetens formula
+         real,parameter :: Pref_solid_liquid=611.14
+         real,parameter :: Trefvaporization=35.86
+         real,parameter :: Trefsublimation=7.66
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
+
+         if (p.lt.Pref_solid_liquid) then ! solid / vapour
+            Tsat =(T_h2O_ice_liq*r3sublimation- Trefsublimation*Log(p/Pref_solid_liquid))/(r3sublimation-Log(p/Pref_solid_liquid))
+         else                 ! liquid / vapour
+            Tsat =(T_h2O_ice_liq*r3vaporization- Trefvaporization*Log(p/Pref_solid_liquid))/(r3vaporization-Log(p/Pref_solid_liquid))
+         endif
+
+         return
+      end subroutine Tsat_water
+
+
+end module watercommon_h
Index: trunk/LMDZ.GENERIC/libf/phystd/watersat.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/watersat.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/watersat.F90	(revision 728)
@@ -29,13 +29,17 @@
 
   if (T.lt.T_h2O_ice_liq) then ! solid / vapour
-     qsat = 100.0 * epsi * 10**(2.07023 - 0.00320991             &
+     qsat = 100.0 * 10**(2.07023 - 0.00320991             &
           * T - 2484.896 / T + 3.56654 * alog10(T))
   else                 ! liquid / vapour
-     qsat = 100.0 * epsi * 10**(23.8319 - 2948.964 / T - 5.028  &
+     qsat = 100.0 * 10**(23.8319 - 2948.964 / T - 5.028  &
           * alog10(T) - 29810.16 * exp( -0.0699382 * T)  &
           + 25.21935 * exp(-2999.924/T))
   endif
-  qsat=qsat/p
-
+!  qsat=epsi*qsat/p
+  if(qsat.gt.p) then
+     qsat=1.
+  else
+     qsat=epsi*qsat/(p-(1.-epsi)*qsat)
+  endif
   return
 end subroutine watersat
